/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.payroll.payment.action;

import java.util.Date;

import jp.mosp.common.common.BaseVo;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;
import jp.mosp.payroll.base.PayrollAction;
import jp.mosp.payroll.base.PayrollConst;
import jp.mosp.payroll.dao.PtCurrentDao;
import jp.mosp.payroll.dto.PtCurrentDto;
import jp.mosp.payroll.payment.vo.EndCalcVo;

/**
 * 給与計算終了画面における処理を行う。<br><br>
 * 以下のコマンドを扱う。
 * <ul><li>
 * {@link #CMD_SHOW}
 * </li><li>
 * {@link #CMD_EXECUTE}
 * </li></ul>
 */
public class EndCalcAction extends PayrollAction {
	
	/**
	 * 画面表示コマンド。<br><br>
	 * 給与計算中の年月を取得、表示する。<br>
	 * もし給与計算中の年月がなかった場合は、警告する。<br>
	 */
	public static final String	CMD_SHOW	= "P1210";
	
	/**
	 * 処理実行コマンド。<br><br>
	 * 表示された計算年月に対して、計算終了状態にする。<br>
	 */
	public static final String	CMD_EXECUTE	= "P1215";
	

	/**
	 * Actionの初期化を行う。<br><br>
	 * 以下の処理を行う。
	 * <ul><li>
	 * {@link PayrollAction#PayrollAction()}
	 * </li></ul>
	 */
	public EndCalcAction() {
		super();
	}
	
	/* (non-Javadoc)
	 * @see jp.mosp.common.common.BaseAction#getSpecificVo()
	 */
	@Override
	protected BaseVo getSpecificVo() {
		return new EndCalcVo();
	}
	
	/**
	 * アクション。<br>
	 * 詳細は、クラス説明を参照。<br>
	 */
	public void action() throws Exception {
		// VO取得及び設定
		prepareVo();
		if (cmd.equals(CMD_SHOW)) {
			// 画面表示
			show();
		} else if (cmd.equals(CMD_EXECUTE)) {
			// 処理実行
			execute();
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}
	
	/**
	 * 画面表示処理を行う。<br>
	 * @throws Exception 
	 */
	@Override
	public void show() throws Exception {
		// コネクション取得
		getConnection();
		// VO取得
		EndCalcVo vo = (EndCalcVo)getVo();
		// 計算中情報取得
		Date current = getCurrent(PayrollConst.OFFICE_ALL, PayrollConst.CALC_PAYMENT);
		// 計算中情報確認
		if (current == null) {
			// 画面モード設定
			vo.setMode(1);
			// 警告メッセージ設定
			vo.addErrMessage(MospUtility.getMessage(msg, "WP1210", ""));
			// 例外スロー
			throw new MospException(MospConst.EX_PARAMS_INVALID);
		}
		// VOフィールド設定
		vo.setCalcDate(current);
		// 画面モード設定
		vo.setMode(0);
	}
	
	/**
	 * 給与計算終了処理を行う。<br>
	 * @throws Exception 
	 */
	private void execute() throws Exception {
		// コネクション取得
		getConnection();
		// VO取得
		EndCalcVo vo = (EndCalcVo)getVo();
		// 対象年月取得
		Date targetMonth = vo.getCalcDate();
		// DAO準備
		PtCurrentDao dao = new PtCurrentDao(cfg, cmd, aspUser, user, conn);
		// 処理対象確認
		PtCurrentDto dto = dao.findForUpdate(PayrollConst.OFFICE_ALL, PayrollConst.CALC_PAYMENT, targetMonth);
		// DTO変更
		dto.setCurrentStatus(PayrollConst.CURRENT_END);
		// 更新
		dao.update(dto);
		// コミット
		commit();
		// 画面モード設定
		vo.setMode(2);
		// メッセージ設定
		vo.setMessage(MospUtility.getMessage(msg, MospConst.MSG_UPDATE, ""));
	}
	
}
